/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.camel.kafkaconnector.iota;

import java.util.Map;
import javax.annotation.Generated;
import org.apache.camel.kafkaconnector.CamelSinkConnectorConfig;
import org.apache.kafka.common.config.ConfigDef;

@Generated("This class has been generated by camel-kafka-connector-generator-maven-plugin, remove this annotation to prevent it from being generated.")
public class CamelIotaSinkConnectorConfig extends CamelSinkConnectorConfig {

    public static final String CAMEL_SINK_IOTA_PATH_NAME_CONF = "camel.sink.path.name";
    public static final String CAMEL_SINK_IOTA_PATH_NAME_DOC = "Component name";
    public static final String CAMEL_SINK_IOTA_PATH_NAME_DEFAULT = null;
    public static final String CAMEL_SINK_IOTA_ENDPOINT_DEPTH_CONF = "camel.sink.endpoint.depth";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_DEPTH_DOC = "The depth determines how deep the tangle is analysed for getting Tips";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_DEPTH_DEFAULT = "9";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_LAZY_START_PRODUCER_CONF = "camel.sink.endpoint.lazyStartProducer";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_LAZY_START_PRODUCER_DOC = "Whether the producer should be started lazy (on the first message). By starting lazy you can use this to allow CamelContext and routes to startup in situations where a producer may otherwise fail during starting and cause the route to fail being started. By deferring this startup to be lazy then the startup failure can be handled during routing messages via Camel's routing error handlers. Beware that when the first message is processed then creating and starting the producer may take a little time and prolong the total processing time of the processing.";
    public static final Boolean CAMEL_SINK_IOTA_ENDPOINT_LAZY_START_PRODUCER_DEFAULT = false;
    public static final String CAMEL_SINK_IOTA_ENDPOINT_MIN_WEIGHT_MAGNITUDE_CONF = "camel.sink.endpoint.minWeightMagnitude";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_MIN_WEIGHT_MAGNITUDE_DOC = "The minWeightMagnitude is the minimum number of zeroes that a proof-of-work output/transaction hash must end with to be considered valid by full nodes";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_MIN_WEIGHT_MAGNITUDE_DEFAULT = "14";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_OPERATION_CONF = "camel.sink.endpoint.operation";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_OPERATION_DOC = "Which operation to perform, one of: sendTransfer, getNewAddress, getTransfers One of: [sendTransfer] [getNewAddress] [getTransfers]";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_OPERATION_DEFAULT = null;
    public static final String CAMEL_SINK_IOTA_ENDPOINT_TAG_CONF = "camel.sink.endpoint.tag";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_TAG_DOC = "TAG";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_TAG_DEFAULT = null;
    public static final String CAMEL_SINK_IOTA_ENDPOINT_URL_CONF = "camel.sink.endpoint.url";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_URL_DOC = "Node url";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_URL_DEFAULT = null;
    public static final String CAMEL_SINK_IOTA_ENDPOINT_BASIC_PROPERTY_BINDING_CONF = "camel.sink.endpoint.basicPropertyBinding";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_BASIC_PROPERTY_BINDING_DOC = "Whether the endpoint should use basic property binding (Camel 2.x) or the newer property binding with additional capabilities";
    public static final Boolean CAMEL_SINK_IOTA_ENDPOINT_BASIC_PROPERTY_BINDING_DEFAULT = false;
    public static final String CAMEL_SINK_IOTA_ENDPOINT_SYNCHRONOUS_CONF = "camel.sink.endpoint.synchronous";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_SYNCHRONOUS_DOC = "Sets whether synchronous processing should be strictly used, or Camel is allowed to use asynchronous processing (if supported).";
    public static final Boolean CAMEL_SINK_IOTA_ENDPOINT_SYNCHRONOUS_DEFAULT = false;
    public static final String CAMEL_SINK_IOTA_ENDPOINT_SECURITY_LEVEL_CONF = "camel.sink.endpoint.securityLevel";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_SECURITY_LEVEL_DOC = "Address security level";
    public static final String CAMEL_SINK_IOTA_ENDPOINT_SECURITY_LEVEL_DEFAULT = "1";
    public static final String CAMEL_SINK_IOTA_COMPONENT_LAZY_START_PRODUCER_CONF = "camel.component.iota.lazyStartProducer";
    public static final String CAMEL_SINK_IOTA_COMPONENT_LAZY_START_PRODUCER_DOC = "Whether the producer should be started lazy (on the first message). By starting lazy you can use this to allow CamelContext and routes to startup in situations where a producer may otherwise fail during starting and cause the route to fail being started. By deferring this startup to be lazy then the startup failure can be handled during routing messages via Camel's routing error handlers. Beware that when the first message is processed then creating and starting the producer may take a little time and prolong the total processing time of the processing.";
    public static final Boolean CAMEL_SINK_IOTA_COMPONENT_LAZY_START_PRODUCER_DEFAULT = false;
    public static final String CAMEL_SINK_IOTA_COMPONENT_BASIC_PROPERTY_BINDING_CONF = "camel.component.iota.basicPropertyBinding";
    public static final String CAMEL_SINK_IOTA_COMPONENT_BASIC_PROPERTY_BINDING_DOC = "Whether the component should use basic property binding (Camel 2.x) or the newer property binding with additional capabilities";
    public static final Boolean CAMEL_SINK_IOTA_COMPONENT_BASIC_PROPERTY_BINDING_DEFAULT = false;

    public CamelIotaSinkConnectorConfig(
            ConfigDef config,
            Map<String, String> parsedConfig) {
        super(config, parsedConfig);
    }

    public CamelIotaSinkConnectorConfig(Map<String, String> parsedConfig) {
        this(conf(), parsedConfig);
    }

    public static ConfigDef conf() {
        ConfigDef conf = new ConfigDef(CamelSinkConnectorConfig.conf());
        conf.define(CAMEL_SINK_IOTA_PATH_NAME_CONF, ConfigDef.Type.STRING, CAMEL_SINK_IOTA_PATH_NAME_DEFAULT, ConfigDef.Importance.HIGH, CAMEL_SINK_IOTA_PATH_NAME_DOC);
        conf.define(CAMEL_SINK_IOTA_ENDPOINT_DEPTH_CONF, ConfigDef.Type.STRING, CAMEL_SINK_IOTA_ENDPOINT_DEPTH_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_IOTA_ENDPOINT_DEPTH_DOC);
        conf.define(CAMEL_SINK_IOTA_ENDPOINT_LAZY_START_PRODUCER_CONF, ConfigDef.Type.BOOLEAN, CAMEL_SINK_IOTA_ENDPOINT_LAZY_START_PRODUCER_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_IOTA_ENDPOINT_LAZY_START_PRODUCER_DOC);
        conf.define(CAMEL_SINK_IOTA_ENDPOINT_MIN_WEIGHT_MAGNITUDE_CONF, ConfigDef.Type.STRING, CAMEL_SINK_IOTA_ENDPOINT_MIN_WEIGHT_MAGNITUDE_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_IOTA_ENDPOINT_MIN_WEIGHT_MAGNITUDE_DOC);
        conf.define(CAMEL_SINK_IOTA_ENDPOINT_OPERATION_CONF, ConfigDef.Type.STRING, CAMEL_SINK_IOTA_ENDPOINT_OPERATION_DEFAULT, ConfigDef.Importance.HIGH, CAMEL_SINK_IOTA_ENDPOINT_OPERATION_DOC);
        conf.define(CAMEL_SINK_IOTA_ENDPOINT_TAG_CONF, ConfigDef.Type.STRING, CAMEL_SINK_IOTA_ENDPOINT_TAG_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_IOTA_ENDPOINT_TAG_DOC);
        conf.define(CAMEL_SINK_IOTA_ENDPOINT_URL_CONF, ConfigDef.Type.STRING, CAMEL_SINK_IOTA_ENDPOINT_URL_DEFAULT, ConfigDef.Importance.HIGH, CAMEL_SINK_IOTA_ENDPOINT_URL_DOC);
        conf.define(CAMEL_SINK_IOTA_ENDPOINT_BASIC_PROPERTY_BINDING_CONF, ConfigDef.Type.BOOLEAN, CAMEL_SINK_IOTA_ENDPOINT_BASIC_PROPERTY_BINDING_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_IOTA_ENDPOINT_BASIC_PROPERTY_BINDING_DOC);
        conf.define(CAMEL_SINK_IOTA_ENDPOINT_SYNCHRONOUS_CONF, ConfigDef.Type.BOOLEAN, CAMEL_SINK_IOTA_ENDPOINT_SYNCHRONOUS_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_IOTA_ENDPOINT_SYNCHRONOUS_DOC);
        conf.define(CAMEL_SINK_IOTA_ENDPOINT_SECURITY_LEVEL_CONF, ConfigDef.Type.STRING, CAMEL_SINK_IOTA_ENDPOINT_SECURITY_LEVEL_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_IOTA_ENDPOINT_SECURITY_LEVEL_DOC);
        conf.define(CAMEL_SINK_IOTA_COMPONENT_LAZY_START_PRODUCER_CONF, ConfigDef.Type.BOOLEAN, CAMEL_SINK_IOTA_COMPONENT_LAZY_START_PRODUCER_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_IOTA_COMPONENT_LAZY_START_PRODUCER_DOC);
        conf.define(CAMEL_SINK_IOTA_COMPONENT_BASIC_PROPERTY_BINDING_CONF, ConfigDef.Type.BOOLEAN, CAMEL_SINK_IOTA_COMPONENT_BASIC_PROPERTY_BINDING_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_IOTA_COMPONENT_BASIC_PROPERTY_BINDING_DOC);
        return conf;
    }
}